﻿using System;
using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;

namespace MaterialModernWPF.Module
{
    public class MainModule : IModule
    {
        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.Register<MainViewModel>();
            containerRegistry.RegisterForNavigation<MainView>();
        }

        public void OnInitialized(IContainerProvider containerProvider)
        {
            var regionManager = containerProvider.Resolve<IRegionManager>();
            regionManager.RequestNavigate(Constants.MainRegion, new Uri(nameof(MainView), UriKind.Relative));
        }
    }
}